//
//Custom colors for multiplayer and the mod itself
//

//Original concept skincolors
freeslot("SKINCOLOR_TOADSTOOL")
skincolors[SKINCOLOR_TOADSTOOL] = {
	name = "Toadstool",
	ramp = {51,54,34,34,35,35,36,37,38,39,41,43,45,187,253,254},
	invcolor = SKINCOLOR_FOREST,
	invshade = 6, 
	chatcolor = V_REDMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_TOADSTOOL, SKINCOLOR_RED)

freeslot("SKINCOLOR_BLUEFLOWER")
skincolors[SKINCOLOR_BLUEFLOWER] = {
	name = "Blueflower",
	ramp = {145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,253},
	invcolor = SKINCOLOR_YELLOW,
	invshade = 3, 
	chatcolor = V_BLUEMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_BLUEFLOWER, SKINCOLOR_BLUE)

freeslot("SKINCOLOR_MUSHROOM")
skincolors[SKINCOLOR_MUSHROOM] = {
	name = "Mushroom",
	ramp = {48,50,52,55,35,36,38,39,40,41,42,43,44,45,46,47},
	invcolor = SKINCOLOR_PURPLE,
	invshade = 8,
	chatcolor = V_REDMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_MUSHROOM, SKINCOLOR_FLAME)

freeslot("SKINCOLOR_SHELL")
skincolors[SKINCOLOR_SHELL] = {
	name = "Shell",
	ramp = {81,88,97,98,99,101,102,103,103,126,127,127,174,175,169,253},
	invcolor = SKINCOLOR_PLUM,
	invshade = 6, 
	chatcolor = V_GREENMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_SHELL, SKINCOLOR_MINT)

freeslot("SKINCOLOR_UNDERGROUND")
skincolors[SKINCOLOR_UNDERGROUND] = {
	name = "Underground",
	ramp = {144,145,170,171,172,172,173,174,174,175,175,253,253,254,254,31},
	invcolor = SKINCOLOR_OLIVE,
	invshade = 0, 
	chatcolor = V_AZUREMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_UNDERGROUND, SKINCOLOR_DUSK)

//Super Mario World
freeslot("SKINCOLOR_MONDO")
skincolors[SKINCOLOR_MONDO] = {
	name = "Mondo",
	ramp = {209,210,32,33,33,34,34,204,205,206,42,44,71,46,47,31},
	invcolor = SKINCOLOR_AQUA,
	invshade = 1, 
	chatcolor = V_REDMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_MONDO, SKINCOLOR_RUBY)

freeslot("SKINCOLOR_TUBULAR")
skincolors[SKINCOLOR_TUBULAR] = {
	name = "Tubular",
	ramp = {128,128,120,120,140,140,140,141,142,142,149,150,151,152,153,154},
	invcolor = SKINCOLOR_SANDY,
	invshade = 1, 
	chatcolor = V_SKYMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_TUBULAR, SKINCOLOR_TEAL)

freeslot("SKINCOLOR_GROOVY")
skincolors[SKINCOLOR_GROOVY] = {
	name = "Groovy",
	ramp = {120,121,122,112,112,113,113,114,114,115,116,126,127,138,139,29},
	invcolor = SKINCOLOR_RUBY,
	invshade = 4, 
	chatcolor = V_GREENMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_GROOVY, SKINCOLOR_EMERALD)

freeslot("SKINCOLOR_FUNKY")
skincolors[SKINCOLOR_FUNKY] = {
	name = "Funky",
	ramp = {144,160,160,161,161,162,162,163,163,164,165,166,167,168,169,159},
	invcolor = SKINCOLOR_WHITE,
	invshade = 0, 
	chatcolor = V_PURPLEMAP,
	accessible = true
}
M_MoveColorAfter(SKINCOLOR_FUNKY, SKINCOLOR_PASTEL)

//Super Mario 64
freeslot("SKINCOLOR_LETHAL")
skincolors[SKINCOLOR_LETHAL] = {
	name = "Lethal",
	ramp = {34,34,35,35,35,35,36,37,38,39,40,41,42,43,44,45},
	invcolor = SKINCOLOR_EMERALD,
	invshade = 10, 
	chatcolor = V_REDMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_LETHAL, SKINCOLOR_RED)

freeslot("SKINCOLOR_DIRE")
skincolors[SKINCOLOR_DIRE] = {
	name = "Dire",
	ramp = {149,149,150,150,150,150,151,152,153,153,154,155,156,157,158,159},
	invcolor = SKINCOLOR_YELLOW,
	invshade = 3, 
	chatcolor = V_BLUEMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_DIRE, SKINCOLOR_BLUE)

freeslot("SKINCOLOR_COURTYARD")
skincolors[SKINCOLOR_COURTYARD] = {
	name = "Courtyard",
	ramp = {96,96,112,112,112,112,113,113,114,114,115,115,116,116,117,117},
	invcolor = SKINCOLOR_RUBY,
	invshade = 4, 
	chatcolor = V_GREENMAP,
	accessible = true
}
M_MoveColorBefore(SKINCOLOR_COURTYARD, SKINCOLOR_EMERALD)

//Super Ball Overalls
freeslot("SKINCOLOR_MOSSBUTDARK")
skincolors[SKINCOLOR_MOSSBUTDARK] = {
	name = "MossButDark",
	ramp = {93,93,93,94,94,94,95,95,95,95,95,95,95,95,95,95},
	invcolor = SKINCOLOR_SALMON,
	invshade = 0,
	chatcolor = V_GREENMAP,
	accessible = false
}
M_MoveColorAfter(SKINCOLOR_MOSSBUTDARK, SKINCOLOR_MOSS)

//
//Rainbow color for Star Power
//

freeslot("SKINCOLOR_RAINBOW")
skincolors[SKINCOLOR_RAINBOW] = {
    name = "Rainbow",
    ramp = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},
    invcolor = SKINCOLOR_JET,
    invshade = 7,
    chatcolor = V_REDMAP,
    accessible = true
}

//I am going to die
local starcolors = {
	{32,33,34,35,36,37,39,40,41,42,43,44,45,71,46,47},
	{32,33,34,35,36,37,39,40,41,42,43,44,45,71,46,47},
	{32,33,34,35,36,37,38,39,40,41,42,43,44,45,71,46},
	{32,32,33,35,36,36,38,39,40,41,62,63,44,45,71,46},
	{219,32,33,34,56,36,59,59,60,60,61,63,63,45,45,46},
	{218,32,33,34,56,56,58,59,59,60,61,62,63,63,45,71},
	{218,220,52,55,55,56,56,57,59,60,60,61,63,63,45,71},
	{218,220,52,53,55,55,57,58,59,59,60,61,62,63,44,45},
	{218,220,51,53,54,55,56,57,58,59,60,61,62,63,63,45},
	{49,50,51,52,53,54,56,57,58,59,59,60,62,63,63,44},
	{49,50,51,52,53,53,53,56,57,58,59,60,61,63,63,44},
	{84,50,51,52,53,53,53,55,57,58,59,60,61,63,63,44},
	{84,64,64,74,74,52,53,53,67,58,59,60,61,63,44,45},
	{84,64,74,74,74,52,52,66,67,58,59,60,62,63,44,45},
	{83,64,74,74,74,52,65,66,67,67,68,69,70,45,45,45},
	{83,72,74,74,74,65,65,66,66,67,68,69,70,45,45,45},
	{72,72,73,73,73,65,65,65,66,67,68,69,70,45,45,45},
	{72,72,73,73,73,64,64,65,66,67,68,69,70,71,71,71},
	{72,72,73,73,73,64,64,65,66,67,68,69,70,71,71,71},
	{72,72,73,73,73,64,64,65,66,67,68,69,70,71,46,46},
	{72,72,73,73,73,64,65,65,66,67,68,69,70,46,46,46},
	{83,83,73,73,74,65,65,66,66,67,231,233,70,46,47,47},
	{83,83,73,73,188,65,65,66,76,77,232,233,236,237,47,47},
	{83,83,74,74,188,65,65,66,76,77,232,233,236,237,239,239},
	{82,82,188,188,188,75,75,76,76,77,232,234,236,237,239,239},
	{82,82,188,188,188,75,189,76,190,77,249,234,236,237,110,110},
	{88,88,188,188,189,189,190,190,190,191,94,94,237,237,110,110},
	{88,88,188,188,189,189,190,190,190,191,94,94,95,95,119,119},
	{89,89,189,189,190,190,190,190,190,191,106,106,108,108,119,119},
	{96,96,189,189,190,190,190,190,190,104,106,106,108,108,119,119},
	{96,96,189,189,190,190,102,102,102,105,106,106,108,108,119,119},
	{96,96,99,99,101,101,103,103,103,105,106,106,108,108,119,119},
	{97,97,100,100,101,101,103,103,103,105,107,107,108,108,119,119},
	{98,98,113,113,114,114,115,115,115,116,107,107,118,118,119,119},
	{112,112,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{112,112,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{112,112,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{112,112,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{112,112,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{98,112,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{97,98,113,113,114,114,115,115,115,116,117,117,118,118,119,119},
	{96,97,123,123,124,124,125,125,125,126,127,127,118,118,118,119},
	{96,122,123,123,124,124,125,125,125,126,127,127,127,127,118,119},
	{121,122,123,123,124,124,125,125,125,126,127,127,127,127,118,119},
	{121,121,123,123,124,124,124,124,124,125,126,126,127,127,118,119},
	{120,121,122,122,123,123,124,124,124,125,126,126,127,127,118,119},
	{120,121,122,122,123,123,124,124,124,142,126,126,127,127,118,119},
	{120,121,121,122,122,122,123,123,123,142,142,143,143,143,109,119},
	{120,129,121,121,122,122,141,141,141,142,142,142,143,143,109,110},
	{120,120,121,121,141,141,141,141,141,136,142,142,143,143,139,110},
	{128,120,121,121,141,141,141,141,141,135,136,142,143,143,139,139},
	{128,120,130,131,132,132,141,141,141,135,136,142,137,137,138,139},
	{128,120,130,130,132,132,133,133,133,135,136,136,137,137,138,139},
	{128,128,129,130,131,131,132,133,133,134,135,136,137,137,138,139},
	{128,128,129,130,131,131,132,133,133,134,135,136,137,137,138,139},
	{128,128,129,130,132,132,133,134,134,134,135,136,137,137,138,139},
	{128,128,129,131,133,133,134,134,134,135,136,136,137,137,138,139},
	{128,145,146,132,134,134,134,135,135,135,136,137,137,137,138,139},
	{145,145,146,133,134,134,135,135,135,135,136,137,138,138,138,139},
	{145,146,146,133,134,135,149,135,135,136,136,137,138,138,139,254},
	{145,146,147,148,149,149,150,150,150,136,137,137,138,138,253,254},
	{145,146,147,148,149,150,150,150,150,154,155,156,158,158,253,254},
	{146,146,147,148,149,150,151,151,154,154,155,157,158,158,253,254},
	{146,147,148,149,150,151,151,153,154,155,156,157,158,159,253,254},
	{146,147,148,149,150,151,152,153,154,155,156,157,158,159,253,254},
	{146,147,148,149,150,150,151,153,154,155,156,157,158,159,253,254},
	{146,147,148,149,150,150,151,151,153,155,156,156,158,169,253,253},
	{145,146,148,149,150,150,151,151,166,167,156,168,158,169,253,253},
	{160,161,162,163,164,165,165,166,166,167,167,167,168,169,169,253},
	{160,161,162,163,164,165,165,165,166,166,167,167,168,168,169,169},
	{160,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{160,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{160,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{160,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{160,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{160,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{178,161,162,163,164,164,165,165,165,166,167,167,168,168,169,169},
	{178,178,180,182,183,183,183,183,183,166,185,185,186,186,187,187},
	{178,178,180,182,182,182,183,183,183,184,185,185,186,186,187,187},
	{178,179,180,181,182,182,183,183,183,184,185,185,186,186,187,187},
	{179,179,180,181,182,182,183,183,183,184,185,185,186,186,187,187},
	{179,179,180,181,182,182,183,183,183,184,185,185,186,186,187,187},
	{179,179,180,182,183,183,184,184,184,184,185,185,186,186,187,187},
	{179,202,202,182,183,183,184,184,184,185,185,186,186,186,187,187},
	{202,202,202,183,204,183,205,184,184,185,186,186,186,187,187,187},
	{202,202,203,204,204,204,205,205,206,207,205,186,187,187,47,47},
	{202,202,33,34,36,37,39,40,40,42,43,44,45,71,46,47},
	{202,32,33,35,36,37,39,40,41,42,43,44,45,71,46,47},
	{32,33,34,35,36,37,39,40,41,42,43,44,45,71,46,47}
}

local currentstarcolor = 0
addHook("ThinkFrame", do
	currentstarcolor = $ + 1
	if currentstarcolor > #starcolors or not starcolors[currentstarcolor]
		currentstarcolor = 1
	end
	
	skincolors[SKINCOLOR_RAINBOW].ramp = starcolors[currentstarcolor]
end)

//Making this color was a hastle and a half

/*local backcolor = CV_RegisterVar({
	name = "backcolor",
	defaultvalue = 1,
	PossibleValue = {MIN = 1, MAX = #starcolors},
})

local frontcolor = CV_RegisterVar({
	name = "frontcolor",
	defaultvalue = 1,
	PossibleValue = {MIN = 1, MAX = #starcolors},
})

local transvalue = CV_RegisterVar({
	name = "transvalue",
	defaultvalue = 1,
	PossibleValue = {MIN = 0, MAX = 10},
})

hud.add(function(v, player, cam)
	local patch = v.cachePatch("MRPAL")
	v.draw(100, 100, patch, 0, v.getColormap(0, starcolors[backcolor.value]))
	
	if transvalue.value != 10
		v.draw(100, 100, patch, transvalue.value<<FF_TRANSSHIFT,
		v.getColormap(0, starcolors[frontcolor.value]))
	end
end)*/